# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/ibm-wsdl4j/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section         free
%define cvs_version     1_6_2
%define namedversion %{version}-redhat-1

%define shortname wsdl4j

Name:           wsdl4j-eap6
Version:        1.6.2
Release:        10%{?dist}
Epoch:          0
Summary:        Web Services Description Language Toolkit for Java
Group:          Text Processing/Markup/XML
License:        CPL
URL:            http://sourceforge.net/projects/wsdl4j/
%if ! %{gcj_support}
BuildArch:      noarch
%endif
# cvs -d:pserver:anonymous@wsdl4j.cvs.sourceforge.net:/cvsroot/wsdl4j login 
# cvs -z3 -d:pserver:anonymous@wsdl4j.cvs.sourceforge.net:/cvsroot/wsdl4j export -r wsdl4j-1_6_2 wsdl4j 
Source0:        wsdl4j-%{version}-src.tar.gz
# pom.xml has been adapted with vman-1.0.5-redhat-1.jar
Source1:        wsdl4j-%{version}.pom
Source2:        wsdl4j-component-info.xml

Requires:       jaxp_parser_impl
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  java-devel
BuildRequires:  jboss-parent
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  junit
# To create content for maven2-brew
BuildRequires:  maven-deploy-plugin
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Web Services Description Language for Java Toolkit (WSDL4J) allows the
creation, representation, and manipulation of WSDL documents describing
services.  This codebase will eventually serve as a reference implementation
of the standard created by JSR110.

%package -n %{shortname}
Summary:        Web Services Description Language Toolkit for Java
Group:          Text Processing/Markup/XML
Requires:       jaxp_parser_impl

%description -n %{shortname}
The Web Services Description Language for Java Toolkit (WSDL4J) allows the
creation, representation, and manipulation of WSDL documents describing
services.  This codebase will eventually serve as a reference implementation
of the standard created by JSR110.

%package -n %{shortname}-javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{shortname}

%description -n %{shortname}-javadoc
Javadoc for %{shortname}.

%if %{with_repolib}
%package -n %{shortname}-repolib
Summary:         Artifacts to be uploaded to a repository library
Group:           Development/Libraries/Java

%description -n %{shortname}-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{shortname}
find . -name '*.jar' | xargs -t %{__rm}

mkdir tmpsrc
%{jar} -cf tmpsrc/%{shortname}-src.jar src

%build
export CLASSPATH=
export OPT_JAR_LIST="ant/ant-junit junit"
ant -Ddebug=true -Dbuild.compiler=modern compile test javadocs

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 build/lib/%{shortname}.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{shortname}-%{namedversion}.jar
install -m 644 build/lib/qname.jar \
      $RPM_BUILD_ROOT%{_javadir}/wsdl-qname-%{namedversion}.jar
touch $RPM_BUILD_ROOT%{_javadir}/qname.jar # for %ghost

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{namedversion}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

# Alternative JAR location
install -m 644 build/lib/%{shortname}.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}/%{shortname}-%{namedversion}.jar
install -m 644 build/lib/qname.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}/wsdl-qname-%{namedversion}.jar
touch $RPM_BUILD_ROOT%{_javadir}/%{name}/qname.jar # for %ghost

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{namedversion}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

%add_to_maven_depmap wsdl4j wsdl4j %{namedversion} JPP wsdl4j

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-wsdl4j.pom

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{shortname}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{shortname}-%{version}/
ln -s %{shortname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{shortname}

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	%{_bindir}/mvn-jpp deploy:deploy-file \
	-DgroupId=wsdl4j \
	-DartifactId=wsdl4j \
	-Dversion=%{namedversion} \
	-Dpackaging=jar \
	-Dfile=%{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar \
	-DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{shortname}.pom \
	-Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
	-DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file \
	-DgroupId=wsdl4j \
	-DartifactId=wsdl4j \
	-Dversion=%{namedversion} \
	-Dpackaging=java-source \
    -DgeneratePom=false \
	-Dfile=tmpsrc/%{shortname}-src.jar \
	-Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
	-DrepositoryId=jboss-releases
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        sed -i "s/@VERSION@/%{namedversion}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
        tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
        sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p $RPM_BUILD_ROOT%{_javadir}/wsdl4j.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p tmpsrc/%{shortname}-src.jar $RPM_BUILD_ROOT%{repodirlib}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirlib}/wsdl4j.pom
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n %{shortname}
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/qname.jar qname %{_javadir}/wsdl-qname.jar 00100
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post
%{_sbindir}/update-alternatives --install %{_javadir}/qname.jar qname %{_javadir}/%{name}/wsdl-qname.jar 00100
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun -n %{shortname}
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove qname %{_javadir}/wsdl-qname.jar
fi
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove qname %{_javadir}/wsdl-qname.jar
fi
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%ghost %{_javadir}*/%{name}/qname.jar
%{_javadir}*/%{name}/*jar

%files -n %{shortname}
%defattr(0644,root,root,0755)
%doc license.html
%ghost %{_javadir}*/qname.jar
%{_javadir}*/wsdl-qname-%{namedversion}.jar
%{_javadir}*/wsdl-qname.jar
%{_javadir}*/wsdl-qname.jar
%{_javadir}*/wsdl4j-%{namedversion}.jar
%{_javadir}*/wsdl4j.jar
%{_datadir}/maven2/poms/*
%config(noreplace) %{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%attr(-,root,root) %{_libdir}/gcj/%{name}/qname-%{version}.jar.*
%endif

%files -n %{shortname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{shortname}-%{version}
%{_javadocdir}/%{shortname}

%if %{with_repolib}
%files -n %{shortname}-repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Apr 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.2-10
- Fix alternatives configuration for the main package

* Thu Apr 05 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.6.2-9.2
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.2-9.1.1
- Rebuild using cache signing

* Wed Feb 29 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.6.2-9.1
- Build with full version 1.6.2-redhat-1

* Mon Jan 17 2011 Hui Wang <huwang@redhat.com> - 0:1.6.2-9
- Rebuild
- Fix name of installing pom
- Using deploy command instead if upload.sh

* Mon Nov 15 2010 Hui Wang <huwang@redhat.com> - 0:1.6.2-8
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars

* Mon Jun 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.6.2-7.1
- Fix Release tag

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.6.2-6.2.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.6.2-6.2
- Rebuild

* Mon Dec 07 2009 David Walluck <dwalluck@redhat.com> 0:1.6.2-6.1
- fix repolib and gcj_support options

* Fri Feb 06 2009 Ralph Apel <r.apel at r-apel.de> 0:1.6.2-6.jpp5
- Fix qname*.jar alternatives

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 1.6.2-5
- Auto rebuild for JPackage 5 in mock

* Wed Nov 19 2008 David Walluck <dwalluck@redhat.com> 0:1.6.2-4
- fix file list
- fix repolib
- fix component-info.xml
- fix GCJ support

* Thu May 29 2008 David Walluck <dwalluck@redhat.com> 0:1.6.2-3.jpp5
- add repolib option
- enable debug
- remove spurious gnu-crypto dependency
- remove javadoc scriptlets
- use %%{_sbindir} macro
- fix License
- fix macro in %%changelog
- encode spec as utf8
- remove Vendor and Distribution tags
- remove Requires: java

* Thu May 31 2007 Ralph Apel <r.apel at r-apel.de> 0:1.6.2-2jpp
- Rename and create alternative for qname.jar

* Mon May 28 2007 Ralph Apel <r.apel at r-apel.de> 0:1.6.2-1jpp
- update to 1.6.2
- Make Vendor, Distribution based on macro
- Fix aot build
- Install pom, depmap frag

* Thu Aug 10 2006 Deepak Bhole <dbhole@redhat.com> 1.5.2-4jpp
- Added missing requirements.

* Wed Jul 19 2006 Deepak Bhole <dbhole@redhat.com> 0:1.5.2-3jpp
- Remove name/release/version defines as applicable.

* Tue Jul 18 2006 Deepak Bhole <dbhole@redhat.com> 0:1.5.2-2jpp
- Merge changes from fc.
- Add conditional native compilation.

* Mon Jan 30 2006 Ralph Apel <r.apel at r-apel.de> 0:1.5.2-1jpp
- update to 1.5.2
- move qname*.jar to %%{_javadir}/wsdl4j/qname*.jar
  to make place for qname provided by geronimo-specs

* Thu Jun 02 2005 Fernando Nasser <fnasser@redhat.com> 0:1.5.1-1jpp
- update to 1.5.1

* Fri Mar 11 2005 Ralph Apel <r.apel at r-apel.de> 0:1.5-1jpp
- update to 1.5

* Mon Aug 30 2004 Ralph Apel <r.apel at r-apel.de> 0:1.4-3jpp
- Build with ant-1.6.2

* Thu Jun 26 2003 Nicolas Mailhot <Nicolas.Mailhot at laPoste.net> 0:1.4-2jpp
- Do not drop qname.jar

* Tue May 06 2003 David Walluck <david@anti-microsoft.org> 0:1.4-1jpp
- 1.4
- update for JPackage 1.5

* Sat Sep  7 2002 Ville Skyttä <ville.skytta at iki.fi> 1.1-1jpp
- First JPackage release.
